import React from 'react';
import { render } from 'react-dom';
import { HashRouter as Router, Route } from 'react-router-dom';
import { Provider } from 'react-redux';
import composeReducer from './compose-reducers';
import config from '_/src/app-config';
import initI18N from './i18n'; //import from local file

import PageProxy from './page-proxy';
import configureStore from './configure-store';
import reducer from '_/src/reducers';
var store = configureStore(reducer);
var mountTarget = config.el || 'bsMain';

if (typeof mountTarget === 'string') {
  mountTarget = document.getElementById(mountTarget);
}

var bootstrap = function bootstrap(node) {
  render(React.createElement(Provider, {
    store: store
  }, React.createElement(Router, null, React.createElement(Route, {
    path: "*",
    component: PageProxy
  }))), node);
};

var start = function start() {
  bootstrap(mountTarget);
};

initI18N(start);

if (module.hot) {
  module.hot.accept('./page-proxy', start);
  module.hot.accept('_/src/reducers', function () {
    var reducer = require('_/src/reducers').default;

    store.replaceReducer(composeReducer(reducer));
  });
}