import "core-js/modules/es6.promise";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.string.iterator";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.regexp.split";
import "core-js/modules/es6.regexp.match";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from "react";
import App from "_/src/entry";
var tabPattern = "/~/";
var currentPage = "$$currentPage";
var df = "default";

var PageProxy =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(PageProxy, _Component);

  function PageProxy() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {};
    return _this;
  }

  var _proto = PageProxy.prototype;

  _proto.getPagePath = function getPagePath(props) {
    var _ref = props || this.props,
        url = _ref.match.url;

    var path = url.substr(1) || "home";
    return path.split(tabPattern);
  };

  _proto.componentWillMount = function componentWillMount() {
    this.loadAsyncPages(this.getPagePath());
  };

  _proto.isPathChange = function isPathChange(path1, path2) {
    var l1 = path1.length;
    var l2 = path2.length;

    if (l1 !== l2) {
      return true;
    } else {
      var i;

      for (i = 0; i < l1.length; i++) {
        if (l1[i] !== l2[i]) {
          return true;
        }
      }
    }

    return false;
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var currentPath = this.getPagePath();
    var nextPath = this.getPagePath(nextProps);

    if (currentPath, nextPath) {
      this.loadAsyncPages(nextPath);
    }
  };

  _proto.renderTabElement = function renderTabElement(tabPaths, pagePath) {
    var _this2 = this;

    var tabArray = this.getTabPathArray(tabPaths, pagePath);
    return tabArray.reduceRight(function (element, oneTabPath) {
      var TabClass = _this2.state[oneTabPath];

      if (!TabClass) {
        return null;
      }

      var tabName = oneTabPath.split('/').pop();

      if (element) {
        return React.cloneElement(React.createElement(TabClass, {
          _tabName: tabName
        }), null, element);
      } else {
        return React.createElement(TabClass, {
          _tabName: tabName
        });
      }
    }, null);
  };

  _proto.renderPageElement = function renderPageElement() {
    var state = this.state;

    var _this$getPagePath = this.getPagePath(),
        pagePath = _this$getPagePath[0],
        tabPath = _this$getPagePath[1];

    var PageComponent = state[pagePath];
    var pageElement = !!PageComponent ? React.createElement(PageComponent, this.props) : React.createElement("div", null, "loading...");
    var tabElement = null;

    if (tabPath) {
      tabElement = this.renderTabElement(tabPath, pagePath);
    }

    return React.cloneElement(pageElement, {}, tabElement);
  };

  _proto.render = function render() {
    var pageElement = this.renderPageElement();
    return React.createElement(App, this.props, pageElement);
  };

  _proto.getTabPathArray = function getTabPathArray(tabPath, pagePath) {
    if (tabPath === void 0) {
      tabPath = "";
    }

    if (pagePath === void 0) {
      pagePath = "";
    }

    var tabArray = [];
    var tempTabRecord = "";
    tabPath.split("/").forEach(function (item, index) {
      tempTabRecord += index === 0 ? item : "/" + item;
      tabArray.push(pagePath + "/" + tempTabRecord);
    });
    return tabArray;
  };

  _proto.warn = function warn(msg, err) {
    console && console.log && console.log(msg, err);
  };

  _proto.loadAsyncPages = function loadAsyncPages(path) {
    var _this3 = this;

    var pagePath = path[0];
    var tabPath = path[1];
    var loadTabs = [],
        tabsArray = tabPath ? this.getTabPathArray(tabPath, pagePath) : [],
        loadPage = this.state[pagePath] ? false : import(
    /* webpackMode: "lazy", webpackChunkName: "[request]" */
    "_/src/pages/" + pagePath + "/page-view");

    if (tabPath) {
      loadTabs = tabsArray.map(function (item) {
        if (!_this3.state[item]) {
          return import(
          /* webpackMode: "lazy-once", webpackChunkName: "tabs" */
          "_/src/pages/" + item + "/tab-view");
        } else {
          return _this3.state[item];
        }
      });
    }

    Promise.all([loadPage]).then(function (_ref2) {
      var PageComponent = _ref2[0];
      var needUpdate = false;
      var updateData = {};

      if (PageComponent) {
        needUpdate = true;
        updateData[pagePath] = PageComponent[df];
      }

      if (_this3.state[currentPage] !== pagePath) {
        needUpdate = true;
        updateData[currentPage] = pagePath;
      }

      if (needUpdate) {
        _this3.setState(updateData);
      }

      Promise.all(loadTabs).then(function (tabViews) {
        tabViews.forEach(function (tabview, index) {
          var tabPath = tabsArray[index];

          if (!_this3.state[tabPath]) {
            var _this3$setState;

            _this3.setState((_this3$setState = {}, _this3$setState[tabPath] = tabview[df], _this3$setState));
          }
        });
      }).catch(function (err) {
        _this3.warn("\u52A0\u8F7D " + pagePath + " \u9875\u9762\u4E0B\u7684Tab " + tabPath + " \u5931\u8D25", err);
      });
    }).catch(function (err) {
      _this3.warn("\u9875\u9762 " + pagePath + " \u52A0\u8F7D\u5931\u8D25", err);
    });
  };

  return PageProxy;
}(Component);

export default PageProxy;